SystemOrganization addCategory: #SourceCity!

!RPackage methodsFor: '*SourceCity' stamp: 'DouailleErwan 4/2/2012 16:02'!
numberOfClasses
	^ self classes size! !

!RPackage methodsFor: '*SourceCity' stamp: 'DouailleErwan 4/2/2012 16:01'!
numberOfDefinedClasses
	^ self definedClasses size! !

!RPackage methodsFor: '*SourceCity' stamp: 'DouailleErwan 4/2/2012 16:02'!
numberOfExtendedClasses
	^ self extendedClasses size! !

!RPackage methodsFor: '*SourceCity' stamp: 'DouailleErwan 4/4/2012 11:59'!
numberOfMethod: aClass
	^ aClass selectors size! !

TestCase subclass: #BuildingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!BuildingTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/4/2012 17:48'!
testColorMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	
	self assert: c city districts size =1.
	self assert: c city widthSelector = 1. 
	

	(c city districts) do:[
		:eachDistrict|
		((eachDistrict model) classes) do:[
			:eachBuilding|
			c importClassAsBuilding: eachBuilding district: eachDistrict.
			].
		].
	
	self assert: (c city districts at: 1)buildings size =2.
	self assert: c city widthSelector = 1.
	self assert: (c city districts at:1) widthSelector = 2.
	self assert: ((c city districts at:1) buildings at:1) colorSelector =0.
	self assert: ((c city districts at:1) buildings at:2) colorSelector =0.! !

!BuildingTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/4/2012 17:45'!
testHeightMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	
	self assert: c city districts size =1.
	self assert: c city widthSelector = 1. 

	(c city districts) do:[
		:eachDistrict|
		((eachDistrict model) classes) do:[
			:eachBuilding|
			c importClassAsBuilding: eachBuilding district: eachDistrict.
			].
		].
	
	self assert: (c city districts at: 1)buildings size =2.
	self assert: c city widthSelector = 1.
	self assert: (c city districts at:1) widthSelector = 2.
	self assert: ((c city districts at:1) buildings at:1) heightSelector =202.
	self assert: ((c city districts at:1) buildings at:2) heightSelector =241.! !

!BuildingTest methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 4/4/2012 17:43'!
testWidthMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	
	self assert: c city districts size =1.
	self assert: c city widthSelector = 1. 
	

	(c city districts) do:[
		:eachDistrict|
		((eachDistrict model) classes) do:[
			:eachBuilding|
			c importClassAsBuilding: eachBuilding district: eachDistrict.
			].
		].
	
	self assert: (c city districts at: 1)buildings size =2.
	self assert: c city widthSelector = 1.
	self assert: (c city districts at:1) widthSelector = 2.
	self assert: ((c city districts at:1) buildings at:1) widthSelector =0.
	self assert: ((c city districts at:1) buildings at:2) widthSelector =2814.! !

TestCase subclass: #CityImporterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/4/2012 16:58'!
testDisplayFullyImportOfRing
	"self debug: #testFullyImportOfRing"
	
	| cimport ring build height |
	cimport := CityImporter new.
	ring := RPackageOrganizer default packageNames.
	cimport cityNamed: 'CodCT' withPackageNames: ring.
	(cimport city districts) do:[
		:each|
		((each model) classes) do:[
			:eachClass|
			cimport importClassAsBuilding: eachClass district: each.
			].
		].
	"self assert: cimport city districts size = 481.
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city hasDistrictNamed: #'SourceCity')."
	"Transcript cr;show:cimport city size."
	build := 0.
	height := 0.
	(cimport city districts) do:[
		:each|
		(each buildings) do:[
			:eachClass|
			build := build+1.
			(height<eachClass heightSelector)
			ifTrue: [height := (eachClass heightSelector).Transcript cr;show:eachClass;show:height].
			].
		].
	Transcript clear;show:'1 ville - ';show:cimport city districts size;show: ' districts - ';show: build;show:' buildings le plus haut fait : ';show:height.
	"Transcript cr;show: (RPackage new numberOfClasses)."! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/4/2012 13:50'!
testFullyImportOfRing
	"self debug: #testFullyImportOfRing"
	
	| cimport ring build height |
	cimport := CityImporter new.
	ring := RPackageOrganizer default packageNames.
	cimport cityNamed: 'CodCT' withPackageNames: ring.
	(cimport city districts) do:[
		:each|
		((each model) classes) do:[
			:eachClass|
			cimport importClassAsBuilding: eachClass district: each.
			].
		].
	"self assert: cimport city districts size = 481.
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city hasDistrictNamed: #'SourceCity')."
	"Transcript cr;show:cimport city size."
	build := 0.
	height := 0.
	(cimport city districts) do:[
		:each|
		(each buildings) do:[
			:eachClass|
			build := build+1.
			(height<eachClass heightSelector)
			ifTrue: [height := (eachClass heightSelector).Transcript cr;show:eachClass;show:height].
			].
		].
	Transcript clear;show:'1 ville - ';show:cimport city districts size;show: ' districts - ';show: build;show:' buildings le plus haut fait : ';show:height.
	"Transcript cr;show: (RPackage new numberOfClasses)."! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/3/2012 14:18'!
testImportClassAsBuilding
	"self debug: #testImportClassAsBuilding"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: cimport city districts size =1.
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	(cimport city districts) do:[
		:each|
		((each model) classes) do:[
			:eachClass|
			cimport importClassAsBuilding: eachClass district: each.
			].
		].
	self assert: cimport city districts size =1.
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city districts at: 1)buildings size =2.
	
	! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/2/2012 15:40'!
testImportPackageAsDistrict
	"self debug: #testImportPackageAsDistrict"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: cimport city districts size =1.
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 4/3/2012 13:51'!
testImportPackageAsDistrictNoDuplicate
	"self debug: #testImportPackageAsDistrictNoDuplicate"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' 'SourceCity' 'AST-Core').
	self assert: cimport city districts size = 2.
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city hasDistrictNamed: #'SourceCity').
	! !

TestCase subclass: #DistrictTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!DistrictTest methodsFor: 'tests' stamp: 'DouailleErwan 4/4/2012 17:34'!
testMetricsConfig
	"self debug: #testMetricsConfig"
	
	| p d c |
	c := CityImporter new.
	c cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: c city districts size =1.
	self assert: c city widthSelector = 1. ! !

Object subclass: #CityImporter
	instanceVariableNames: 'classes methods packages city districts buildings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityImporter commentStamp: '<historical>' prior: 0!
I'm responsible for populating a city from a model (usually a ring model)!

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/4/2012 17:49'!
basicBuilding: aClassName district: aDistrict

	 | b couleur |
	b := Building new model:  aClassName;hisDistrict: aDistrict.
	b heightSelector: (aClassName selectors) size.
	b widthSelector: (aClassName allSubclasses) size.
	"TODO: COLOR
	(aClassName selectors) do:[:each|
		couleur := each li"

	aDistrict add: b.
	^b
	! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/4/2012 16:37'!
basicDistrict: aPackageName city: aCity

	 | d |
	d := District new model: (self packageNamed: aPackageName);hisCity: aCity.
	city add: d.
	^d
	
	! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:33'!
city
	^city! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/4/2012 10:21'!
cityNamed: aName withPackageNames: aCol

	city := City new name: aName.
	aCol do: [:each |
				self importPackageAsDistrict: each ]! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:23'!
districts
	^ city districts.! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/2/2012 17:08'!
ensureBuilding: aClassName

	^ buildings
			at: aClassName 
			ifAbsentPut: [ self basicBuilding: aClassName].
			
						! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:58'!
ensureBuilding: aClassName district: aDistrict

	^ buildings
			at: aClassName 
			ifAbsentPut: [ self basicBuilding: aClassName district: aDistrict].
			
						! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:48'!
ensureDistrict: aPackageName

	^districts 
			at: aPackageName 
			ifAbsentPut: [ self basicDistrict: aPackageName city: (self city)].
			
						! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/2/2012 17:07'!
importClassAsBuilding: aClassName

	| ctPack |
	ctPack := self ensureDistrict: aClassName.
	! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/3/2012 13:56'!
importClassAsBuilding: aClassName district: aDistrict

	| ctPack |
	ctPack := self ensureBuilding: aClassName district: aDistrict.
	! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 4/2/2012 15:43'!
importPackageAsDistrict: aPackageName

	| ctPack |
	ctPack := self ensureDistrict: aPackageName.
	! !

!CityImporter methodsFor: 'initialize-release' stamp: 'DouailleErwan 4/3/2012 14:08'!
initialize

	super initialize.
	districts := Dictionary new.
	buildings := Dictionary new.! !

!CityImporter methodsFor: 'utils' stamp: 'DouailleErwan 4/2/2012 14:28'!
packageNamed: aString

	^ RPackageOrganizer default packageNamed: aString! !

Object subclass: #CityObject
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!CityObject commentStamp: '<historical>' prior: 0!
I'm an abstract class root of the city elements!

CityObject subclass: #Building
	instanceVariableNames: 'hisDistrict heightSelector widthSelector colorSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!Building commentStamp: '<historical>' prior: 0!
A Building is the level abstraction.!

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 14:50'!
colorSelector
	^ colorSelector! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 14:50'!
colorSelector: anObject
	colorSelector := anObject! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 14:49'!
heightSelector
	^heightSelector! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 16:20'!
heightSelector: anObject
	heightSelector:=anObject.! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:33'!
hisDistrict
	^hisDistrict ! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 14:04'!
hisDistrict: aDistrict
	hisDistrict := aDistrict.! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/4/2012 17:48'!
initialize

	self widthSelector: 0.
	self colorSelector: 0.
	self heightSelector: 0.
	! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 22:25'!
printOn: aStream

	super printOn: aStream.
	hisDistrict ifNotNil: [
					(hisDistrict hisCity) ifNotNil: [ aStream
							nextPutAll: ' CITY : '; 
							nextPutAll: hisDistrict hisCity name ; 
							nextPutAll: ' = '].
					 aStream
					nextPutAll: ' DISTRICT  : '; 
					nextPutAll: hisDistrict name ; 
					nextPutAll: ' = '].
					
	model ifNotNil: [ aStream 
					nextPutAll: ' Buidling Name : '; 
					nextPutAll: model name].! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 14:50'!
widthSelector
	^ widthSelector! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 14:50'!
widthSelector: anObject
	widthSelector := anObject! !

CityObject subclass: #City
	instanceVariableNames: 'districts name widthSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!City commentStamp: '<historical>' prior: 0!
A City represents the largest model element. It contains a list of districts.!

!City methodsFor: 'adding' stamp: 'DouailleErwan 4/4/2012 16:56'!
add: aDistrict

	districts add: aDistrict.
	self widthSelector: (districts size).
	^ aDistrict! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:36'!
districts

	^ districts! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 14:51'!
districts: anObject
	districts := anObject! !

!City methodsFor: 'testing' stamp: 'DouailleErwan 4/2/2012 14:48'!
hasDistrictNamed: aString
	
	^ districts anySatisfy: [:each | each model name = aString]! !

!City methodsFor: 'initialize-release' stamp: 'DouailleErwan 4/4/2012 17:47'!
initialize

	super initialize.
	"districts := Dictionary new."
	districts := OrderedCollection new.
	self widthSelector: 0.! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:38'!
name
	^ name! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:38'!
name: anObject
	name := anObject! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 14:55'!
printOn: aStream

	super printOn: aStream.
	model ifNotNil: [ aStream 
					nextPutAll: ' CITY : '; 
					nextPutAll: model name].! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/4/2012 16:43'!
widthSelector
	^widthSelector! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 4/4/2012 16:42'!
widthSelector: anObject
	widthSelector := anObject.! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:10'!
model 
	"Returns the model associated with the receiver, it can be a class, package...."
	
	^model! !

!CityObject methodsFor: 'accessing' stamp: 'DouailleErwan 4/2/2012 14:10'!
model: aModel
	"Set the model associated with the receiver, it can be a class, package...."
	
	model := aModel! !

CityObject subclass: #District
	instanceVariableNames: 'hisCity buildings widthSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity'!

!District commentStamp: '<historical>' prior: 0!
A District is a secondary city abstractions!

!District methodsFor: 'printing' stamp: 'DouailleErwan 4/4/2012 16:40'!
add: aBuilding

	buildings add: aBuilding.
	self widthSelector: (buildings size).
	^ aBuilding.! !

!District methodsFor: 'configuration' stamp: 'DouailleErwan 4/3/2012 14:15'!
buildings
	^buildings! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:32'!
hisCity
	^hisCity.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 4/3/2012 11:32'!
hisCity: aCity
	hisCity := aCity.! !

!District methodsFor: 'configuration' stamp: 'DouailleErwan 4/4/2012 16:41'!
initialize 
	

	super initialize.
	"buildings := Dictionary new."
	buildings := OrderedCollection new.
	self widthSelector: 0.! !

!District methodsFor: 'printing' stamp: 'DouailleErwan 4/3/2012 14:57'!
printOn: aStream

	super printOn: aStream.
	hisCity ifNotNil: [ aStream
					nextPutAll: ' CITY : '; 
					nextPutAll: hisCity name ; 
					nextPutAll: ' = '].
					
	model ifNotNil: [ aStream 
					nextPutAll: ' Name : '; 
					nextPutAll: model name ].! !

!District methodsFor: 'configuration' stamp: 'DouailleErwan 4/2/2012 15:53'!
widthSelector
	^ widthSelector! !

!District methodsFor: 'configuration' stamp: 'DouailleErwan 4/2/2012 15:53'!
widthSelector: anObject
	widthSelector := anObject! !
